function F = fcn_polyfit(x,param)
% Author:           Benjamin Schuler
% Company:          University of Stuttgart, Institute for System Dynamics
% Last modified:    11.02.2019 (Matlab 2015a)

% polynomial degree
nPol_g = param.nFit_g;
nPol_f = param.nFit_f;

% measurement data at characteristic wavenumbers
ds1 = param.ds(1);
ds2 = param.ds(2);
ds3 = param.ds(3);

% set of nonlinear equations F(ds)=0
F = zeros(3,1);
switch nPol_g
    case 1;
        F = F+[sum([0 0 x(1) 1].*param.a);...
               sum([0 0 x(1) 1].*param.b);...
               sum([0 0 x(1) 1].*param.c)];
    case 2;
        F = F+[sum([0 x(1)^2 x(1) 1].*param.a);...
               sum([0 x(1)^2 x(1) 1].*param.b);...
               sum([0 x(1)^2 x(1) 1].*param.c)];
    case 3;
        F = F+[sum([x(1)^3 x(1)^2 x(1) 1].*param.a);...
               sum([x(1)^3 x(1)^2 x(1) 1].*param.b);...
               sum([x(1)^3 x(1)^2 x(1) 1].*param.c)];
end
switch nPol_f
    case 1;
        F = F+[sum([0 0 x(2) 1].*param.d);...
               sum([0 0 x(2) 1].*param.e);...
               sum([0 0 x(2) 1].*param.f)];
    case 2;
        F = F+[sum([0 x(2)^2 x(2) 1].*param.d);...
               sum([0 x(2)^2 x(2) 1].*param.e);...
               sum([0 x(2)^2 x(2) 1].*param.f)];
    case 3;
        F = F+[sum([x(2)^3 x(2)^2 x(2) 1].*param.d);...
               sum([x(2)^3 x(2)^2 x(2) 1].*param.e);...
               sum([x(2)^3 x(2)^2 x(2) 1].*param.f)];
end
F = F-[ds1; ds2; ds3];